## edu.wisc.ssec.mcidas
Class GVARnav

    java.lang.Object
      edu.wisc.ssec.mcidas.AREAnav
          edu.wisc.ssec.mcidas.GVARnav

All Implemented Interfaces:
  Serializable

public class GVARnav
extends AREAnav

The GVARnav class creates the ability to navigate GVAR image data. It is a math copy of the McIDAS nvxgvar.dlm code. When used with AreaFile class, set up like this:

      AreaFile af;
      try {
        af = new AreaFile("/home/user/mcidas/data/AREA0001");
      } catch (AreaFileException e) {
        System.out.println(e);
        return;
      }
      int[] dir;
      try { dir=af.getDir();
      } catch (AreaFileException e){
        System.out.println(e);
        return;
      }
      int[] nav;
      try { nav=af.getNav();
      } catch (AreaFileException e){
        System.out.println(e);
        return;
      }
      try {
        GVARnav ng = new GVARnav(nav);  // XXXXnav is the specific implementation
      } catch (IllegalArgumentException excp) {
        System.out.println(excp);
        return;
      }
      ng.setImageStart(dir[5], dir[6]);
      ng.setRes(dir[11], dir[12]);
      ng.setStart(1,1);
      ......................

See Also:
  Serialized Form

Field Summary
`(package private) double` `AE`
`(package private) float` `AEBE2`
`(package private) float` `AEBE3`
`(package private) float` `AEBE4`
`(package private) int` `CUTOF1`
`(package private) int` `CUTOF2`
`(package private) double` `DEG`
`(package private) int` `DGL1`
`(package private) int` `DGL2`
`(package private) int` `DGL3`
`(package private) int` `DGL4`
`(package private) int` `DGL5`
`(package private) int` `DGL6`
`(package private) int` `DGL7`
`(package private) int` `DGL8`
`(package private) int` `DGL9`
`(package private) int` `DOY1`
`(package private) int` `DOY2`
`(package private) int` `DOY3`
`(package private) int` `DOY4`
`(package private) int` `DOY5`
`(package private) int` `DOY6`
`(package private) int` `DOY7`
`(package private) int` `DOY8`
`(package private) int` `DOY9`
`(package private) int` `EDTIME`
`(package private) int` `ETIME`
`(package private) int` `EXPTIM`
`(package private) double` `FER`
`(package private) int` `FLPFLG`
`(package private) int` `IDNTFR`
`(package private) int` `IMCACT`
`(package private) int` `IMCFLG`
`(package private) int` `IMCPTC`
`(package private) int` `IMCROL`
`(package private) int` `IMCYAW`
`(package private) int` `IMGDAY`
`(package private) int` `IMGSND`
`(package private) int` `IMGTM`
`(package private) int` `IOFEC`
`(package private) int` `IOFEI`
`(package private) int` `IOFNC`
`(package private) int` `IOFNI`
`(package private) int` `IYFLIP`
`(package private) int` `LDR1`
`(package private) int` `LDR10`
`(package private) int` `LDR11`
`(package private) int` `LDR12`
`(package private) int` `LDR13`
`(package private) int` `LDR2`
`(package private) int` `LDR3`
`(package private) int` `LDR4`
`(package private) int` `LDR5`
`(package private) int` `LDR6`
`(package private) int` `LDR7`
`(package private) int` `LDR8`
`(package private) int` `LDR9`
`(package private) int` `MXCDSZ`
`boolean` `navTransformOK`
`(package private) double` `NOMORB`
`(package private) int` `OASIZE`
`(package private) int` `PAAWDS`
`(package private) int` `PCOEFS`
`(package private) double` `PI`
`(package private) int` `PMAWDS`
`(package private) int` `RAAWDS`
`(package private) double` `RAD`
`(package private) int` `RATPTC`
`(package private) int` `RATROL`
`(package private) int` `RATYAW`
`(package private) int` `RDDR1`
`(package private) int` `RDDR10`
`(package private) int` `RDDR11`
`(package private) int` `RDDR2`
`(package private) int` `RDDR3`
`(package private) int` `RDDR4`
`(package private) int` `RDDR5`
`(package private) int` `RDDR6`
`(package private) int` `RDDR7`
`(package private) int` `RDDR8`
`(package private) int` `RDDR9`
`(package private) int` `REFDIS`
`(package private) int` `REFLAT`
`(package private) int` `REFLON`
`(package private) int` `REFYAW`
`(package private) int[][]` `RELLST`
`(package private) int` `RMACFS`
`(package private) int` `RMAWDS`
`(package private) int` `STTYPE`
`(package private) int` `YAAWDS`

Fields inherited from class edu.wisc.ssec.mcidas.AREAnav
`DEGREES_TO_RADIANS, DMSP, GMSX, GOES, GVAR, indexEle, indexLat, indexLine, indexLon, LALO, LAMB, LL, MERC, MOLL, MSAT, MSG, MSGT, POES, PS, RADIANS_TO_DEGREES, RADR, RECT, serialVersionUID, TANC, XY`

Constructor Summary
`GVARnav(int[] iparms)` Set up for the real math work.
`GVARnav(int ifunc, int[] iparms)` Deprecated. Since ifunc must be 1, replaced with #GVARnav(int[] iparms). If ifunc != 1, ifunc is set to 1.

Method Summary
`double[][]` `toLatLon(double[][] linele)` converts from satellite coordinates to latitude/longitude
`float[][]` `toLatLon(float[][] linele)` converts from satellite coordinates to latitude/longitude
`double[][]` `toLinEle(double[][] latlon)` toLinEle converts lat/long to satellite line/element
`float[][]` `toLinEle(float[][] latlon)` toLinEle converts lat/long to satellite line/element

Methods inherited from class edu.wisc.ssec.mcidas.AREAnav
`areaCoordToImageCoord, areaCoordToImageCoord, areaCoordToImageCoord, areaCoordToImageCoord, doubleToFloat, equals, floatToDouble, getLineOffset, imageCoordToAreaCoord, imageCoordToAreaCoord, imageCoordToAreaCoord, imageCoordToAreaCoord, isFlippedLineCoordinates, makeAreaNav, makeAreaNav, setFlipLineCoordinates, setImageStart, setMag, setMag, setRes, setRes, setStart, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### navTransformOK

    public boolean navTransformOK

### PI

    final double PI

See Also:
  Constant Field Values

### DEG

    final double DEG

See Also:
  Constant Field Values

### RAD

    final double RAD

See Also:
  Constant Field Values

### NOMORB

    final double NOMORB

See Also:
  Constant Field Values

### AE

    final double AE

See Also:
  Constant Field Values

### FER

    final double FER

See Also:
  Constant Field Values

### AEBE2

    final float AEBE2

### AEBE3

    final float AEBE3

### AEBE4

    final float AEBE4

### STTYPE

    final int STTYPE

See Also:
  Constant Field Values

### IDNTFR

    final int IDNTFR

See Also:
  Constant Field Values

### IMCACT

    final int IMCACT

See Also:
  Constant Field Values

### IYFLIP

    final int IYFLIP

See Also:
  Constant Field Values

### REFLON

    final int REFLON

See Also:
  Constant Field Values

### REFDIS

    final int REFDIS

See Also:
  Constant Field Values

### REFLAT

    final int REFLAT

See Also:
  Constant Field Values

### REFYAW

    final int REFYAW

See Also:
  Constant Field Values

### RATROL

    final int RATROL

See Also:
  Constant Field Values

### RATPTC

    final int RATPTC

See Also:
  Constant Field Values

### RATYAW

    final int RATYAW

See Also:
  Constant Field Values

### ETIME

    final int ETIME

See Also:
  Constant Field Values

### EDTIME

    final int EDTIME

See Also:
  Constant Field Values

### IMCROL

    final int IMCROL

See Also:
  Constant Field Values

### IMCPTC

    final int IMCPTC

See Also:
  Constant Field Values

### IMCYAW

    final int IMCYAW

See Also:
  Constant Field Values

### LDR1

    final int LDR1

See Also:
  Constant Field Values

### LDR2

    final int LDR2

See Also:
  Constant Field Values

### LDR3

    final int LDR3

See Also:
  Constant Field Values

### LDR4

    final int LDR4

See Also:
  Constant Field Values

### LDR5

    final int LDR5

See Also:
  Constant Field Values

### LDR6

    final int LDR6

See Also:
  Constant Field Values

### LDR7

    final int LDR7

See Also:
  Constant Field Values

### LDR8

    final int LDR8

See Also:
  Constant Field Values

### LDR9

    final int LDR9

See Also:
  Constant Field Values

### LDR10

    final int LDR10

See Also:
  Constant Field Values

### LDR11

    final int LDR11

See Also:
  Constant Field Values

### LDR12

    final int LDR12

See Also:
  Constant Field Values

### LDR13

    final int LDR13

See Also:
  Constant Field Values

### RDDR1

    final int RDDR1

See Also:
  Constant Field Values

### RDDR2

    final int RDDR2

See Also:
  Constant Field Values

### RDDR3

    final int RDDR3

See Also:
  Constant Field Values

### RDDR4

    final int RDDR4

See Also:
  Constant Field Values

### RDDR5

    final int RDDR5

See Also:
  Constant Field Values

### RDDR6

    final int RDDR6

See Also:
  Constant Field Values

### RDDR7

    final int RDDR7

See Also:
  Constant Field Values

### RDDR8

    final int RDDR8

See Also:
  Constant Field Values

### RDDR9

    final int RDDR9

See Also:
  Constant Field Values

### RDDR10

    final int RDDR10

See Also:
  Constant Field Values

### RDDR11

    final int RDDR11

See Also:
  Constant Field Values

### DGL1

    final int DGL1

See Also:
  Constant Field Values

### DGL2

    final int DGL2

See Also:
  Constant Field Values

### DGL3

    final int DGL3

See Also:
  Constant Field Values

### DGL4

    final int DGL4

See Also:
  Constant Field Values

### DGL5

    final int DGL5

See Also:
  Constant Field Values

### DGL6

    final int DGL6

See Also:
  Constant Field Values

### DGL7

    final int DGL7

See Also:
  Constant Field Values

### DGL8

    final int DGL8

See Also:
  Constant Field Values

### DGL9

    final int DGL9

See Also:
  Constant Field Values

### DOY1

    final int DOY1

See Also:
  Constant Field Values

### DOY2

    final int DOY2

See Also:
  Constant Field Values

### DOY3

    final int DOY3

See Also:
  Constant Field Values

### DOY4

    final int DOY4

See Also:
  Constant Field Values

### DOY5

    final int DOY5

See Also:
  Constant Field Values

### DOY6

    final int DOY6

See Also:
  Constant Field Values

### DOY7

    final int DOY7

See Also:
  Constant Field Values

### DOY8

    final int DOY8

See Also:
  Constant Field Values

### DOY9

    final int DOY9

See Also:
  Constant Field Values

### EXPTIM

    final int EXPTIM

See Also:
  Constant Field Values

### RAAWDS

    final int RAAWDS

See Also:
  Constant Field Values

### PAAWDS

    final int PAAWDS

See Also:
  Constant Field Values

### YAAWDS

    final int YAAWDS

See Also:
  Constant Field Values

### RMAWDS

    final int RMAWDS

See Also:
  Constant Field Values

### PMAWDS

    final int PMAWDS

See Also:
  Constant Field Values

### IMGDAY

    final int IMGDAY

See Also:
  Constant Field Values

### IMGTM

    final int IMGTM

See Also:
  Constant Field Values

### IMGSND

    final int IMGSND

See Also:
  Constant Field Values

### IOFNC

    final int IOFNC

See Also:
  Constant Field Values

### IOFEC

    final int IOFEC

See Also:
  Constant Field Values

### IOFNI

    final int IOFNI

See Also:
  Constant Field Values

### IOFEI

    final int IOFEI

See Also:
  Constant Field Values

### MXCDSZ

    final int MXCDSZ

See Also:
  Constant Field Values

### OASIZE

    final int OASIZE

See Also:
  Constant Field Values

### PCOEFS

    final int PCOEFS

See Also:
  Constant Field Values

### RMACFS

    final int RMACFS

See Also:
  Constant Field Values

### CUTOF1

    final int CUTOF1

See Also:
  Constant Field Values

### CUTOF2

    final int CUTOF2

See Also:
  Constant Field Values

### IMCFLG

    final int IMCFLG

See Also:
  Constant Field Values

### FLPFLG

    final int FLPFLG

See Also:
  Constant Field Values

### RELLST

    final int[][] RELLST

Constructor Detail

### GVARnav

    public GVARnav(int[] iparms)
            throws IllegalArgumentException

  Set up for the real math work. Must pass in the int array of the GVAR nav 'codicil'.

Parameters:
  `iparms` - the nav block from the image file
Throws:
  `IllegalArgumentException` - if the nav block is not a GVAR type.

### GVARnav

    public GVARnav(int ifunc,
                   int[] iparms)
            throws IllegalArgumentException

  Deprecated. Since ifunc must be 1, replaced with #GVARnav(int[] iparms). If ifunc != 1, ifunc is set to 1.

  Set up for the real math work. Must pass in the int array of the GVAR nav 'codicil'.

Parameters:
  `ifunc` - the function to do (always 1 for now)
  `iparms` - the nav block from the image file
Throws:
  `IllegalArgumentException` - if the nav block is not a GVAR type.

Method Detail

### toLatLon

    public double[][] toLatLon(double[][] linele)

  converts from satellite coordinates to latitude/longitude

  Specified by:
    `toLatLon` in class `AREAnav`
  Returns:
    latlon[][] array of lat/lon pairs. Output array is latlon[indexLat][] of latitudes and latlon[indexLon][] of longitudes.

### toLatLon

    public float[][] toLatLon(float[][] linele)

  converts from satellite coordinates to latitude/longitude

  Overrides:
    `toLatLon` in class `AREAnav`
  Returns:
    latlon[][] array of lat/lon pairs. Output array is latlon[indexLat][] of latitudes and latlon[indexLon][] of longitudes.

### toLinEle

    public double[][] toLinEle(double[][] latlon)

  toLinEle converts lat/long to satellite line/element

  Specified by:
    `toLinEle` in class `AREAnav`
  Returns:
    linele[][] array of line/element pairs. Where linele[indexLine][] is a line and linele[indexEle][] is an element. These are in 'file' coordinates (not "image" coordinates);

### toLinEle

    public float[][] toLinEle(float[][] latlon)

  toLinEle converts lat/long to satellite line/element

  Overrides:
    `toLinEle` in class `AREAnav`
  Returns:
    linele[][] array of line/element pairs. Where linele[indexLine][] is a line and linele[indexEle][] is an element. These are in 'file' coordinates (not "image" coordinates);